int main(int argc, char* argv[]) {
	framework.open_framework(argc, argv);
	framework.set_window_title("My Panda3D Window");
	// open the window
	window = framework.open_window();
	
	// test collision sphere / collision capsule

	// create ground plande
	PT(CollisionPolygon) gcp = new CollisionPolygon(LVecBase3(-3, -3, -1.0), LVecBase3(3, -3, -1.0), 
												    LVecBase3(3, 3, -1.0), LVecBase3(-3, 3, -1.0));
	PT(CollisionNode) gcp_cn = new CollisionNode("coll polygon collision node");
	gcp_cn->add_solid(gcp);
	NodePath gcp_np = window->get_render().attach_new_node(gcp_cn);
	gcp_np.set_y(10);
	gcp_np.show();

	// add sphere
	PT(CollisionSphere) cs = new CollisionSphere(0.0f, 0.0f, 0.0f, 0.25f);
	PT(CollisionNode) sphere_cn = new CollisionNode("Sphere CN");
	sphere_cn->add_solid(cs);
	NodePath sphere_np = window->get_render().attach_new_node(sphere_cn);
	//sphere_np.set_fluid_pos(0,10,-1);		// ==> collides   (as expected)
	sphere_np.set_fluid_pos(0,50,-1);		// ==> doesn't collide (as expected)
	sphere_np.show();

	// add capsule
	PT(CollisionCapsule) cc = new CollisionCapsule(-1, 0, 0, 1, 0, 0, 0.3);
	PT(CollisionNode) capsule_cn = new CollisionNode("Capsule CN");
	capsule_cn->add_solid(cc);
	NodePath capsule_np = window->get_render().attach_new_node(capsule_cn);
	capsule_np.set_fluid_pos(0,10,-1);	// ==> collides (as expected)
	//capsule_np.set_fluid_pos(0,100,-1);	// ==> collides (not expected)
	capsule_np.show();

	// create queue + traverser
	PT(CollisionHandlerQueue) coll_queue = new CollisionHandlerQueue();
	CollisionTraverser traverser("Collision Traverser");
	traverser.set_respect_prev_transform(true);
	traverser.add_collider(sphere_np, coll_queue);
	traverser.add_collider(capsule_np, coll_queue);

	// traverse
	traverser.traverse(window->get_render());

	framework.main_loop();
	framework.close_framework();

	return (0);
}